# coding=utf-8
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

import plpy

def is_var_one_hot_encoded_for_minibatch(table_name, var_name):
    query = """SELECT array_upper({var_name}, 2) > 1 AS is_encoded FROM
              {table_name} LIMIT 1;""".format(**locals())
    result = plpy.execute(query)
    if not result[0]["is_encoded"]:
        plpy.error("MiniBatch expects the variable {0} to be one hot encoded."
                   " You might need to re run the minibatch_preprocessor function"
                   " and make sure that the variable is encoded".format(var_name))
